package cz.cvut.fel.f2p.skladaniVln;


import net.java.games.jogl.GL;

public class CameraSettings {

	/**
	 * @uml.property  name="cameraRadius"
	 */
	private double cameraRadius = 25;
	/**
	 * @uml.property  name="cameraTranslationX"
	 */
	private double cameraTranslationX;
	/**
	 * @uml.property  name="cameraTranslationY"
	 */
	private double cameraTranslationY;
	/**
	 * @uml.property  name="cameraTranslationZ"
	 */
	private double cameraTranslationZ;
	/**
	 * @uml.property  name="cameraAlfa"
	 */
	private double cameraAlfa = 10;
	/**
	 * @uml.property  name="cameraBeta"
	 */
	private double cameraBeta = 15;
	/**
	 * @uml.property  name="cameraUpX"
	 */
	private double cameraUpX = 0;
	/**
	 * @uml.property  name="cameraUpY"
	 */
	private double cameraUpY = 1;
	/**
	 * @uml.property  name="cameraUpZ"
	 */
	private double cameraUpZ = 0;
	/**
	 * @uml.property  name="cameraEyeX"
	 */
	private double cameraEyeX = 0;
	/**
	 * @uml.property  name="cameraEyeY"
	 */
	private double cameraEyeY = 0;
	/**
	 * @uml.property  name="cameraEyeZ"
	 */
	private double cameraEyeZ = cameraRadius;
	
	/**
	 * @uml.property  name="camCenterX"
	 */
	public double camCenterX;
	/**
	 * @uml.property  name="camCenterY"
	 */
	public double camCenterY;
	/**
	 * @uml.property  name="camCenterZ"
	 */
	public double camCenterZ;
	
	/**
	 * @uml.property  name="center"
	 * @uml.associationEnd  multiplicity="(1 1)"
	 */
	public Vertex center;
	
	/**
	 * @uml.property  name="matrix" multiplicity="(0 -1)" dimension="1"
	 */
	private double[] matrix = new double[] {1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1};
	
	public CameraSettings() {
		super();
		center = new Vertex(0,0,0,0);
	}
	
	public void compute(GL gl) {
		gl.glMatrixMode(GL.GL_MODELVIEW);
		double d = cameraRadius*Math.cos((cameraBeta*(Math.PI/180)));
		cameraEyeX = d*Math.sin((cameraAlfa*(Math.PI/180)));
		cameraEyeY = cameraRadius*Math.sin((cameraBeta*(Math.PI/180)));
		cameraEyeZ = d*Math.cos((cameraAlfa*(Math.PI/180)));
	
		gl.glPushMatrix();
		gl.glLoadIdentity();
		
		gl.glRotated(cameraAlfa,0,1,0);
		gl.glRotated(cameraBeta,1,0,0);
		//gl.glRotated(cameraGama,0,0,1);
		
		
		double[] matrix = new double[16];
		gl.glGetDoublev(GL.GL_MODELVIEW_MATRIX,matrix);
		gl.glPopMatrix();
		//cameraUpX = matrix[1*4 + 0] + matrix[3*4 + 0];
		cameraUpY = matrix[1*4 + 1] + matrix[3*4 + 1];
		//cameraUpZ = matrix[1*4 + 2] + matrix[3*4 + 2];
	}
	
	public void resetCamera() {
		cameraAlfa = 0;
		cameraBeta = 0;
	}

	/**
	 * @return  the cameraTranslationZ
	 * @uml.property  name="cameraTranslationZ"
	 */
	public double getCameraTranslationZ() {
		return cameraTranslationZ;
	}

	/**
	 * @param cameraTranslationZ  the cameraTranslationZ to set
	 * @uml.property  name="cameraTranslationZ"
	 */
	public void setCameraTranslationZ(double cameraEyeZ) {
		this.cameraTranslationZ = cameraEyeZ;
	}

	/**
	 * @return  the cameraRadius
	 * @uml.property  name="cameraRadius"
	 */
	public double getCameraRadius() {
		return cameraRadius;
	}

	/**
	 * @param cameraRadius  the cameraRadius to set
	 * @uml.property  name="cameraRadius"
	 */
	public void setCameraRadius(double cameraRadius) {
		this.cameraRadius = cameraRadius;
	}

	/**
	 * @return  the matrix
	 * @uml.property  name="matrix"
	 */
	public double[] getMatrix() {
		return matrix;
	}

	/**
	 * @param matrix  the matrix to set
	 * @uml.property  name="matrix"
	 */
	public void setMatrix(double[] matrix) {
		this.matrix = matrix;
	}

	/**
	 * @return  the cameraAlfa
	 * @uml.property  name="cameraAlfa"
	 */
	public double getCameraAlfa() {
		return cameraAlfa;
	}

	/**
	 * @param cameraAlfa  the cameraAlfa to set
	 * @uml.property  name="cameraAlfa"
	 */
	public void setCameraAlfa(double cameraAlpha) {
		this.cameraAlfa = cameraAlpha;
	}

	/**
	 * @return  the cameraBeta
	 * @uml.property  name="cameraBeta"
	 */
	public double getCameraBeta() {
		return cameraBeta;
	}

	/**
	 * @param cameraBeta  the cameraBeta to set
	 * @uml.property  name="cameraBeta"
	 */
	public void setCameraBeta(double cameraBeta) {
		this.cameraBeta = cameraBeta;
	}

	/**
	 * @return  the cameraTranslationX
	 * @uml.property  name="cameraTranslationX"
	 */
	public double getCameraTranslationX() {
		return cameraTranslationX;
	}

	/**
	 * @param cameraTranslationX  the cameraTranslationX to set
	 * @uml.property  name="cameraTranslationX"
	 */
	public void setCameraTranslationX(double camTranslationX) {
		this.cameraTranslationX = camTranslationX;
	}

	/**
	 * @return  the cameraTranslationY
	 * @uml.property  name="cameraTranslationY"
	 */
	public double getCameraTranslationY() {
		return cameraTranslationY;
	}

	/**
	 * @param cameraTranslationY  the cameraTranslationY to set
	 * @uml.property  name="cameraTranslationY"
	 */
	public void setCameraTranslationY(double camTranslationY) {
		this.cameraTranslationY = camTranslationY;
	}

	/**
	 * @return  the center
	 * @uml.property  name="center"
	 */
	public Vertex getCenter() {
		return center;
	}

	/**
	 * @return  the cameraEyeX
	 * @uml.property  name="cameraEyeX"
	 */
	public double getCameraEyeX() {
		return cameraEyeX;
	}

	/**
	 * @return  the cameraEyeY
	 * @uml.property  name="cameraEyeY"
	 */
	public double getCameraEyeY() {
		return cameraEyeY;
	}

	/**
	 * @return  the cameraEyeZ
	 * @uml.property  name="cameraEyeZ"
	 */
	public double getCameraEyeZ() {
		return cameraEyeZ;
	}

	/**
	 * @return  the cameraUpX
	 * @uml.property  name="cameraUpX"
	 */
	public double getCameraUpX() {
		return cameraUpX;
	}

	/**
	 * @return  the cameraUpY
	 * @uml.property  name="cameraUpY"
	 */
	public double getCameraUpY() {
		return cameraUpY;
	}

	/**
	 * @return  the cameraUpZ
	 * @uml.property  name="cameraUpZ"
	 */
	public double getCameraUpZ() {
		return cameraUpZ;
	}

}
