package cz.cvut.fel.f2p.skladaniVln;


import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.MouseWheelEvent;
import java.awt.event.MouseWheelListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollBar;
import javax.swing.JTextField;

import net.java.games.jogl.GLCanvas;
import net.java.games.jogl.GLCapabilities;
import net.java.games.jogl.GLDrawableFactory;

public class SkladaniVln extends JPanel implements MouseListener,MouseMotionListener,MouseWheelListener,ActionListener{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	private GLCanvas canvas;
	private Renderer renderer;
	private int prevX = 0;
	private int prevY = 0;
	private JScrollBar scrollBar;
	private JTextField amplitude;
	private JTextField k;
	private JTextField vawesCountForAdding;
	private JTextField time;
	
	private JTextField addingStep;
	private JCheckBox timeOrientation;
	private JScrollBar vawesCount;
	private JCheckBox fill;
	private JRadioButton omegaSQRT;
	private JTextField omegap; 

	public SkladaniVln() {
		super();
		setLayout(new BorderLayout());
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(1,4));
		
		JButton start = new JButton("Start animate");
		start.addActionListener(this);
		start.setActionCommand("start");
		buttonPanel.add(start);
		
		JButton stop = new JButton("Stop animate");
		stop.addActionListener(this);
		stop.setActionCommand("stop");
		buttonPanel.add(stop);
		
		JButton restart = new JButton("restart");
		restart.addActionListener(this);
		restart.setActionCommand("restart");
		buttonPanel.add(restart);
		
		add(buttonPanel,"South");
		
		canvas = GLDrawableFactory.getFactory().createGLCanvas(
				new GLCapabilities());
		add(canvas,"Center");
		renderer = new Renderer(this);
		canvas.addGLEventListener(renderer);
		canvas.addMouseListener(this);
		canvas.addMouseMotionListener(this);
		canvas.addMouseWheelListener(this);
		
		
	}
	
	public SkladaniVln(boolean x) {
		super();
		setLayout(new BorderLayout());
		canvas = GLDrawableFactory.getFactory().createGLCanvas(
				new GLCapabilities());
		add(canvas,"Center");
		renderer = new Renderer(this);
		canvas.addGLEventListener(renderer);
		canvas.addMouseListener(this);
		canvas.addMouseMotionListener(this);
		canvas.addMouseWheelListener(this);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new GridLayout(1,4));
		
		JButton start = new JButton("Spust animaci");
		start.addActionListener(this);
		start.setActionCommand("start");
		buttonPanel.add(start);
		
		JButton stop = new JButton("Zastav animaci");
		stop.addActionListener(this);
		stop.setActionCommand("stop");
		buttonPanel.add(stop);
		
		JButton restart = new JButton("Obnov");
		restart.addActionListener(this);
		restart.setActionCommand("restart");
		buttonPanel.add(restart);
		
		JButton recompute = new JButton("Obnov nastaveni kamery");
		recompute.addActionListener(this);
		recompute.setActionCommand("recompute");
		buttonPanel.add(recompute);
		
		JPanel north = new JPanel();
		north.setLayout(new BorderLayout());
		
		
		
		JPanel values = new JPanel();
		values.setLayout(new GridLayout(6,2));
		
		
		
		values.add(new JLabel("rychlost animace"));
		
		scrollBar = new JScrollBar(JScrollBar.HORIZONTAL);
		scrollBar.setMinimum(0);
		scrollBar.setMaximum(50);
		scrollBar.setValue(15);
		values.add(scrollBar);
		
		amplitude = new JTextField();
		amplitude.setText("5");
		k = new JTextField();
		k.setText("20");
		values.add(new JLabel("amplituda"));
		values.add(amplitude);
		values.add(new JLabel("vlnov vektor k(kx)"));
		values.add(k);
		
		values.add(new JLabel("pocet scitanych vln"));
		vawesCountForAdding = new JTextField();
		vawesCountForAdding.setText("500");
		values.add(vawesCountForAdding);
		
		values.add(new JLabel("krok k pri scitani"));
		addingStep = new JTextField();
		addingStep.setText("0.01");
		values.add(addingStep);
		
		time = new JTextField();
		time.setText("0");
		
		
		JPanel timePanel = new JPanel();
		timePanel.setLayout(new GridLayout(1,2));
		timePanel.add(new JLabel("cas"));
		timeOrientation = new JCheckBox("zporn bh asu");
		timeOrientation.addActionListener(this);
		timePanel.add(timeOrientation);
		
		values.add(timePanel);
		
		values.add(time);
		values.setBorder(BorderFactory.createRaisedBevelBorder());
		
		JPanel omega = new JPanel();
		omega.setBorder(BorderFactory.createRaisedBevelBorder());
		omega.setLayout(new GridLayout(4,1));
		ButtonGroup bg = new ButtonGroup();
		JRadioButton omegaLinear = new JRadioButton("c*k");
		omegaLinear.setPreferredSize(new Dimension(350,0));
		omegaSQRT = new JRadioButton("sqrt(c2*k2+wp*wp)");
		bg.add(omegaLinear);
		bg.add(omegaSQRT);
		omegaLinear.setSelected(true);
		omega.add(omegaLinear);
		
		JPanel omegaFunctionPanel = new JPanel();
		omegaFunctionPanel.setLayout(new GridLayout(1,2));
		omegaFunctionPanel.add(omegaSQRT);
		JPanel wpt = new JPanel();
		wpt.setLayout(new GridLayout(1,2));
		wpt.add(new JLabel("wp"));
		omegap = new JTextField();
		omegap.setText("10");
		wpt.add(omegap);
		omegaFunctionPanel.add(wpt);
		
		omega.add(omegaFunctionPanel);
		JPanel vawesCountPanel = new JPanel();
		vawesCountPanel.setLayout(new GridLayout(1,2));
		vawesCountPanel.add(new JLabel("pocet vln"));
		vawesCount = new JScrollBar(JScrollBar.HORIZONTAL);
		vawesCount.setMinimum(1);
		vawesCount.setMaximum(15);
		vawesCount.setValue(1);
		vawesCountPanel.add(vawesCount);
		
		JPanel fillPanel = new JPanel();
		fillPanel.setLayout(new GridLayout(1,2));
		fillPanel.add(new JLabel("zapnout vypln"));
		fill = new JCheckBox("");
		fill.addActionListener(this);
		fill.setSelected(true);
		fillPanel.add(fill);
		
		omega.add(vawesCountPanel);
		omega.setPreferredSize(new Dimension(300,0));
		
		omega.add(fillPanel);
		
		north.add(omega,"East");
		north.add(values,"Center");
		
		add(north,"North");
		buttonPanel.setBorder(BorderFactory.createRaisedBevelBorder());
		add(buttonPanel,"South");
		
		JFrame frame = new JFrame("Skladani rovinnych vln");
		Container pane = frame.getContentPane();
		pane.setLayout(new BorderLayout());
		pane.add(SkladaniVln.this,"Center");
		
		frame.setSize(800,600);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setVisible(true);
	}
	
	public void repaint() {
		super.repaint();
		if (canvas != null) {
			canvas.repaint();
		}
	}
	
	public static void main(String[] a) {
		new SkladaniVln(true);
	}

	public void mouseClicked(MouseEvent arg0) {
		prevX = arg0.getX();
		prevY = arg0.getY();
	}

	public void mouseEntered(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mouseExited(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mousePressed(MouseEvent arg0) {
		prevX = arg0.getX();
		prevY = arg0.getY();
	}

	public void mouseReleased(MouseEvent arg0) {
		// TODO Auto-generated method stub
		
	}

	public void mouseDragged(MouseEvent arg0) {
		renderer.getCamSettings().setCameraAlfa(renderer.getCamSettings().getCameraAlfa() - (arg0.getX()-prevX));
		renderer.getCamSettings().setCameraBeta(renderer.getCamSettings().getCameraBeta() + (arg0.getY()-prevY));
		prevX = arg0.getX();
		prevY = arg0.getY();
		repaint();
	}

	public void mouseMoved(MouseEvent arg0) {
		
	}

	public void mouseWheelMoved(MouseWheelEvent arg0) {
		if (arg0.getWheelRotation() > 0) {
			renderer.getCamSettings().setCameraRadius(renderer.getCamSettings().getCameraRadius()-0.5);
		} else {
			renderer.getCamSettings().setCameraRadius(renderer.getCamSettings().getCameraRadius()+0.5);
		}
		repaint();
	}

	public void actionPerformed(ActionEvent arg0) {
		if (arg0.getActionCommand().equals("start")) {
			renderer.setPaused(false);
			repaint();
		} else if (arg0.getActionCommand().equals("stop")) {
			renderer.setPaused(true);
		} else if (arg0.getActionCommand().equals("restart")) {
			renderer.compute();
			repaint();
		} else if (arg0.getActionCommand().equals("recompute")) {
			renderer.getCamSettings().resetCamera();
			repaint();
		} else if (arg0.getSource().equals(timeOrientation)) {
			//renderer.setPaused(true);
			if (timeOrientation.isSelected()) {
				//renderer.setTime(renderer.getTime()-Renderer.VALUES_COUNT);
				time.setText(String.valueOf(renderer.getTime()-Renderer.VALUES_COUNT));
			} else {
				//renderer.setTime(renderer.getTime()+Renderer.VALUES_COUNT);
				time.setText(String.valueOf(renderer.getTime()+Renderer.VALUES_COUNT));
			}
			repaint();
			//renderer.setPaused(false);
		} else if (arg0.getSource().equals(fill)) {
			
			repaint();
		}
	}

	public JScrollBar getScrollBar() {
		return scrollBar;
	}

	public JTextField getAmplitud() {
		return amplitude;
	}

	public JTextField getK() {
		return k;
	}

	public JTextField getVawesCountForAdding() {
		return vawesCountForAdding;
	}

	public JTextField getTime() {
		return time;
	}

	public JTextField getStepAdd() {
		return addingStep;
	}

	public void setStepAdd(JTextField stepAdd) {
		this.addingStep = stepAdd;
	}

	public JCheckBox getTimePlus() {
		return timeOrientation;
	}

	public void setTimePlus(JCheckBox timePlus) {
		this.timeOrientation = timePlus;
	}

	public JScrollBar getVawesCount() {
		return vawesCount;
	}

	public JCheckBox getFill() {
		return fill;
	}

	public JRadioButton getOmegaSQRT() {
		return omegaSQRT;
	}

	public JTextField getOmegap() {
		return omegap;
	}

}
