package cz.cvut.fel.f2p.skladaniVln;

public class Vertex {
	
	/**
	 * @uml.property  name="index"
	 */
	private int index;
	
	private boolean isTransformed = false;
	
	private Point point;
	
	public Vertex(double anX,double anY,double anZ,int anIndex) {
		super();
		point = new Point(anX,anY,anZ);
		
		index = anIndex;
	}
	
	public void translate(double tx,double ty,double tz) {
		point.x += tx;
		point.y += ty;
		point.z += tz;
	}

	/**
	 * @return  the x
	 * @uml.property  name="x"
	 */
	public double getX() {
		return point.x;
	}

	/**
	 * @return  the y
	 * @uml.property  name="y"
	 */
	public double getY() {
		return point.y;
	}

	/**
	 * @return  the z
	 * @uml.property  name="z"
	 */
	public double getZ() {
		return point.z;
	}

	/**
	 * @return  the index
	 * @uml.property  name="index"
	 */
	public int getIndex() {
		return index;
	}
	
	public void transform(double[] matrix) {
		double newx;
		double newy;
		double newz;
		
		newx = point.x*matrix[0] + point.y*matrix[0+4] + point.z*matrix[0+8] + matrix[0+12];
		newy = point.x*matrix[1] + point.y*matrix[1+4] + point.z*matrix[1+8] + matrix[1+12];
		newz = point.x*matrix[2] + point.y*matrix[2+4] + point.z*matrix[2+8] + matrix[2+12];
			
		point.x = newx;
		point.y = newy;
		point.z = newz;
	}
	
	public void compareMin(Vertex v) {
		if (v.getX() < point.x) {
			point.x = v.getX();
		}
		if (v.getY() < point.y) {
			point.y = v.getY();
		}
		if (v.getZ() < point.z) {
			point.z = v.getZ();
		}
	}
	
	public void compareMax(Vertex v) {
		if (v.getX() > point.x) {
			point.x = v.getX();
		}
		if (v.getY() > point.y) {
			point.y = v.getY();
		}
		if (v.getZ() > point.z) {
			point.z = v.getZ();
		}
	}

	public void setX(double x) {
		this.point.x = x;
	}

	public void setY(double y) {
		this.point.y = y;
	}

	public void setZ(double z) {
		this.point.z = z;
	}

	public boolean isTransformed() {
		return isTransformed;
	}

	public void setTransformed(boolean isTransformed) {
		this.isTransformed = isTransformed;
	}

}
